%define name		ccache
%define version		2.4
%define release		4mdk

%define compilers	gcc g++ cc c++ gcc-2.96 g++-2.96 gcc-3.3.4 g++-3.3.4 gcc-3.4.3 g++-3.4.3 gcc-4.0.0 g++-4.0.0
%define pkgs		gcc, gcc-c++, gcc2.96, gcc2.96-c++, gcc3.3, gcc3.3-c++, gcc3.4, gcc3.4-c++, gcc4.0, gcc4.0-c++

Summary:		Compiler Cache
Name:			%{name}
Version:		%{version}
Release:		%{release}
Group:			Development/Other
License:		GPL
URL:			http://ccache.samba.org/
Source0:		%{name}-%{version}.tar.bz2
BuildRoot:		%{_tmppath}/%{name}-%{version}-root

%description
ccache is a compiler cache. It acts as a caching pre-processor to 
C/C++ compilers, using the -E compiler switch and a hash to detect 
when a compilation can be satisfied from cache. This often results 
in a 5 to 10 times speedup in common compilations.

To enable ccache's default use, the system admin should modify 
%{_sysconfdir}/sysconfig/ccache to "yes". If its default use is not 
enabled and you wish to use it, simply add %{_libdir}/ccache/bin/ to 
the start of your \$PATH

%prep
%setup -q

%build
%configure2_5x
%make

%__cat <<EOF > %{name}.sh
if [ -f /etc/sysconfig/ccache ]; then
    . /etc/sysconfig/ccache
fi
if [ "\$USE_CCACHE_DEFAULT" = "yes" ]; then
    if [ -z \`echo "\$PATH" | grep "%{_libdir}/ccache/bin"\` ]; then
        export PATH="%{_libdir}/ccache/bin:\$PATH"
    fi
fi
EOF

%__cat <<EOF > %{name}.csh
if ( -f /etc/sysconfig/ccache ) then
    eval \`sed -n 's/^\([^#]*\)=\([^#]*\)/set \1=\2;/p' < /etc/sysconfig/ccache\`
endif
if ( "\$USE_CCACHE_DEFAULT" == "yes" ) then
    if ( "\$path" !~ *%{_libdir}/ccache/bin* ) then
        setenv path = ( %{_libdir}/ccache/bin \$path )
    endif
endif
EOF

%install
%__rm -rf %{buildroot}
%__install -dm 755 %{buildroot}{%{_bindir},%{_libdir}/ccache/bin,%{_mandir}/man1}
%__install -pm 755 ccache %{buildroot}%{_libdir}/ccache/bin
%__install -pm 644 ccache.1 %{buildroot}%{_mandir}/man1
%__install -dm 755 %{buildroot}%{_sysconfdir}/profile.d
%__install -pm 755 %{name}.sh %{name}.csh %{buildroot}%{_sysconfdir}/profile.d
touch %{name}-%{version}.compilers
for name in %{compilers} ; do
  for comp in $name %{_target_platform}-$name ; do
    %__ln_s ccache %{buildroot}%{_libdir}/ccache/bin/$comp
    echo "%ghost %{_libdir}/ccache/bin/$comp" >> %{name}-%{version}.compilers
  done
done

%__mkdir_p %{buildroot}%{_sysconfdir}/sysconfig/
%__cat <<EOF > %{buildroot}/%{_sysconfdir}/sysconfig/%{name}
# Should we add the ccache compiler symlinks to PATH
# yes|no
# Please note that if added to \$PATH the user can still disable 
# it with CCACHE_DISABLE
# If not enabled by default, the user can add %{_libdir}/ccache/bin/
# to their \$PATH
USE_CCACHE_DEFAULT="no"
EOF

%__ln_s %{_libdir}/ccache/bin/ccache %{buildroot}%{_bindir}/ccache

%triggerin -- %{pkgs}
for name in %{compilers} ; do
  for comp in $name %{_target_platform}-$name ; do
    if [ -x %{_bindir}/$comp ] ; then
      %__rm -f %{_libdir}/ccache/bin/$comp
      %__ln_s ccache %{_libdir}/ccache/bin/$comp
    else
      # This block is to support upgrading from < 2.3-0.fdr.1.
      %__rm -f %{_libdir}/ccache/bin/$comp
    fi
  done
done

%triggerpostun -- %{pkgs}
for name in %{compilers} ; do
  for comp in $name %{_target_platform}-$name ; do
    [ -x %{_bindir}/$comp ] || rm -f %{_libdir}/ccache/bin/$comp
  done
done

%clean
rm -rf %{buildroot}

%files -f %{name}-%{version}.compilers
%defattr(-,root,root)
%doc README
%config(noreplace) %{_sysconfdir}/profile.d/%{name}.*sh
%dir %{_libdir}/ccache
%dir %{_libdir}/ccache/bin
%{_bindir}/ccache
%{_libdir}/ccache/bin/ccache
%{_mandir}/man1/ccache.1*
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}

%changelog
* Wed Feb 02 2005 Nick Brown <nickbrown@mandrake.org> 2.4-4mdk
- Update compiler lists

* Sun Sep 26 2004 David Walluck <walluck@mandrake.org> 2.4-3mdk
- fix ccache.sh

* Sun Sep 26 2004 David Walluck <walluck@mandrake.org> 2.4-2mdk
- changed test in ccache.sh slightly
- macros everywhere

* Fri Sep 17 2004 Nick Brown <nickbrown@mandrake.org> 2.4-1mdk
- 2.4

* Mon Sep 13 2004 Nick Brown <nickbrown@mandrake.org> 2.3-10mdk
- instructions on package use

* Sun Sep 12 2004 Nick Brown <nickbrown@mandrake.org> 2.3-9mdk
- Update package and compiler lists

* Tue Sep 07 2004 Nick Brown <nickbrown@mandrake.org> 2.3-8mdk
- Revert last change at request of ghibo@mandrakesoft.com

* Tue Sep 07 2004 Nick Brown <nickbrown@mandrake.org> 2.3-7mdk
- Enable by default

* Sun Aug 29 2004 Nick Brown <nickbrown@mandrake.org> 2.3-6mdk
- Fix typo in ccache.csh

* Tue Aug 24 2004 Nick Brown <nickbrown@mandrake.org> 2.3-5mdk
- Check sysconfig

* Wed Aug 18 2004 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.3-4mdk
- Don't let ccache.sh|csh profile scripts use ccache links before
  default un-ccached compiler.

* Tue Aug 17 2004 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.3-3mdk
- Added ccache in %%{_bindir} for backward compatibility.

* Fri Aug 13 2004 Nick Brown <nickbroon@blueyonder.co.uk> 2.3-2mdk
- As the fedora package, add dynamic support for compilers

* Fri Dec 12 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.3-1mdk
- 2.3
 
* Mon Feb 17 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.2-1mdk
- 2.2

* Thu Feb 06 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.1.1-1mdk
- from Jos Pablo Ezequiel Fernndez <pupeno@kde.org>:
	- Update to 2.1.1

* Tue Jan 07 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.0-1mdk
- 2.0

* Fri Dec 27 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.9-2mdk
- rebuild for rpm and glibc

* Wed Sep 18 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.9-1mdk
- mdk adaptation

* Mon Apr 01 2002 Peter Jones <pjones@redhat.com>
- Created the package
